/* 	_VX_NGNET_DEF_H		below */

#ifdef	_VX_INFO_INIT_

struct fib_table *fib_hash_init(int id);

static inline void vx_info_init_ngnet(struct _vx_ngnet *ngnet)
{
	int index;

	ngnet->dev_base = NULL;
	ngnet->dev_tail = &ngnet->dev_base;
	ngnet->ifindex = 0;

	for (index=0; index<(1 << NG_HASHBITS); index++) {
		INIT_HLIST_HEAD(&ngnet->dev_hash[index].name);
		INIT_HLIST_HEAD(&ngnet->dev_hash[index].index);
	}

	ngnet->fib_main = fib_hash_init(RT_TABLE_MAIN);
	ngnet->fib_local = fib_hash_init(RT_TABLE_LOCAL);
}

static inline void vx_info_exit_ngnet(struct _vx_ngnet *ngnet)
{
	int index;

	for (index=0; index<(1 << NG_HASHBITS); index++) {
		// get rid of devices ...
	}
}

#else	/* _VX_INFO_INIT_ */

#ifndef _VX_NGNET_DEF_H
#define _VX_NGNET_DEF_H

#include <asm/atomic.h>
#include <asm/resource.h>

#include "ngnet.h"

/* context sub struct */

struct _vx_ngnet {
	struct net_device *dev_base;
	struct net_device **dev_tail;
	int ifindex;

	struct _vx_dev_hash {
		struct hlist_head name;
		struct hlist_head index;
	} dev_hash[1 << NG_HASHBITS];

	struct fib_table *fib_main;
	struct fib_table *fib_local;

};

#endif	/* _VX_NGNET_DEF_H */
#endif	/* _VX_INFO_INIT_ */
